int storage[20];
extern void counting_sort(int data[], int size);
extern void radix_sort(int data[], int size);
extern void bubble_sort(int data[], int size);
extern int int_array_reverse_sorted(int data[], int size);
extern int int_array_unsorted(int data[], int size);
extern int int_array_sorted(int data[], int size);
volatile int marker_setup_done;
volatile int marker_data_gen_start;
volatile int marker_data_gen_done;
volatile int marker_func_start;
volatile int marker_func_done;

#include <ee_printf.h>
void marker_system_print()
{
  ee_printf("setup_done=%p\n", &marker_setup_done);
  ee_printf("data_gen_start=%p\n", &marker_data_gen_start);
  ee_printf("data_gen_done=%p\n", &marker_data_gen_done);
  ee_printf("func_start=%p\n", &marker_func_start);
  ee_printf("func_done=%p\n", &marker_func_done);
}
void experiment_info()
{
  ee_printf("experiment_info='");  ee_printf(",int_array_reverse_sorted");
  ee_printf(",counting_sort");
  ee_printf("int_array_reverse_sorted");
  ee_printf(",radix_sort");
  ee_printf("int_array_reverse_sorted");
  ee_printf(",bubble_sort");
  ee_printf("int_array_unsorted");
  ee_printf(",counting_sort");
  ee_printf("int_array_unsorted");
  ee_printf(",radix_sort");
  ee_printf("int_array_unsorted");
  ee_printf(",bubble_sort");
  ee_printf("int_array_sorted");
  ee_printf(",counting_sort");
  ee_printf("int_array_sorted");
  ee_printf(",radix_sort");
  ee_printf("int_array_sorted");
  ee_printf(",bubble_sort");
}
void experiment()
{
asm volatile("": : :"memory");
  marker_setup_done = 0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_reverse_sorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  counting_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_reverse_sorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  radix_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_reverse_sorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  bubble_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_unsorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  counting_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_unsorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  radix_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_unsorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  bubble_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_sorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  counting_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_sorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  radix_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
asm volatile("": : :"memory");
  marker_data_gen_start=0;
asm volatile("": : :"memory");
  int_array_sorted(storage, 20);
asm volatile("": : :"memory");
  marker_data_gen_done=0;
asm volatile("": : :"memory");
  marker_func_start=0;
asm volatile("": : :"memory");
  bubble_sort(storage, 20);
asm volatile("": : :"memory");
  marker_func_done=0;
}
